https://bugs.gentoo.org/show_bug.cgi?id=612860
By Tim Rakowski
We os.walk /usr with followlinks=True, but at least nodejs contains a "recursive" link in /usr/include/node

Index: catkin_pkg-0.4.6/src/catkin_pkg/packages.py
===================================================================
--- catkin_pkg-0.4.6.orig/src/catkin_pkg/packages.py
+++ catkin_pkg-0.4.6/src/catkin_pkg/packages.py
@@ -57,7 +57,9 @@ def find_package_paths(basepath, exclude
     """
     paths = []
     real_exclude_paths = [os.path.realpath(p) for p in exclude_paths] if exclude_paths is not None else []
+    visited = set()
     for dirpath, dirnames, filenames in os.walk(basepath, followlinks=True):
+        visited.add(dirpath)
         if 'AMENT_IGNORE' in filenames or \
             'CATKIN_IGNORE' in filenames or \
             'COLCON_IGNORE' in filenames or \
@@ -70,7 +72,7 @@ def find_package_paths(basepath, exclude
             del dirnames[:]
             continue
         # filter out hidden directories in-place
-        dirnames[:] = [d for d in dirnames if not d.startswith('.')]
+        dirnames[:] = [d for d in dirnames if not d.startswith('.') and not os.path.realpath(os.path.join(dirpath, d)) in visited]
     return paths
 
 
